<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

/*
CREATE TABLE images (
    id      INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
    url     TEXT NOT NULL,
    title   TEXT NULL,
    width   INT(11) UNSIGNED NULL,
    height  INT(11) UNSIGNED NULL,

    PRIMARY KEY(`id`),
    UNIQUE KEY(`url`)
);
 */

final class CreateImagesTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $table = $this->table('images')->addTimestamps();
        $table->addColumn('url', 'string')
              ->addColumn('title', 'string', [ 'null' => false ])
              ->addColumn('width', 'integer', [ 
                  'null' => true,
                  'signed' => false, 
              ])
              ->addColumn('height', 'integer', [
                  'null' => true,
                  'signed' => false
              ])
              ->addIndex([ 'url' ], [ 'type' => 'unique' ])
              ->create();
    }
}
