<?php

namespace Slovocast\Domain\Repository\User;

use Slovocast\Domain\Entity\User;

interface UserRepositoryInterface
{
    public function get(int $id): User;
    public function getFromEmail(string $email): User;

    /**
     * @TODO Add methods for getting a User based on other related data, such
     *       as the Channel or Episode.
     */

    public function create(User $user): bool;
    public function update(User $user): bool;
    public function delete(User $user): bool;
    public function verifyPassword(string $email, string $password): bool;
}
