<?php

namespace Slovocast\Infrastructure\Session;

interface FlashMessagesInterface
{
    /**
     * Add a message to the flash system
     *
     * @param string $level
     * @param string $message
     * @return void
     */
    public function add(string $level, string $message): void;

    /**
     * Returns an array of all the flash messages for the level provided, and
     * clears the cache.
     *
     * @param string $level
     * @return array<string>
     */
    public function get(string $level): array;

    /**
     * @return array<string, array<string>>
     */
    public function all(): array;

    /**
     * @param string|null
     */
    public function clear(?string $level = null): void;
}
